SystemOrganization addCategory: 'OrbeonBizagiReader2'!

Object subclass: #XPDLObject2
	instanceVariableNames: 'attributes xmlString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

XPDLObject2 subclass: #XPDLActivityNode
	instanceVariableNames: 'inTransitions outTransitions loopType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:32'!
initialize

	super initialize.

	inTransitions := OrderedCollection new.
	outTransitions := OrderedCollection new.! !

!XPDLActivityNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:32'!
inTransitions
	^inTransitions! !

!XPDLActivityNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:32'!
inTransitions: newValue
	inTransitions := newValue! !

!XPDLActivityNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:32'!
loopType
	^loopType! !

!XPDLActivityNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:32'!
loopType: newValue
	loopType := newValue! !

!XPDLActivityNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:32'!
outTransitions
	^outTransitions! !

!XPDLActivityNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:32'!
outTransitions: newValue
	outTransitions := newValue! !

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:32'!
setLoopTypeWithNode: xmlNode
	"The receiver set it's loop type from the xml node <xmlNode>
	Loop type: (none) (standart) (multi-instance)"
	| loopNode |

	loopNode := xmlNode findElementNamed: 'Loop'.
	loopNode ifNil: [^self].

	^self loopType: (loopNode attributeAt: 'LoopType')! !

XPDLActivityNode subclass: #XPDLSubProcessNode
	instanceVariableNames: 'subProcess subProcessId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLSubProcessNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:37'!
setParentProcessDataWithNode: xmlNode
	"Set the <id> of the Subprocess of the receiver. The receiver will go to this subprocess when executed"

	self subProcessId: ((xmlNode findElementNamed: 'SubFlow') attributeAt: 'Id')! !

!XPDLSubProcessNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:21'!
subProcess
	^subProcess! !

!XPDLSubProcessNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:21'!
subProcess: newValue
	subProcess := newValue! !

!XPDLSubProcessNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:21'!
subProcessId
	^subProcessId! !

!XPDLSubProcessNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:21'!
subProcessId: newValue
	subProcessId := newValue! !

XPDLActivityNode subclass: #XPDLTaskNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

XPDLObject2 subclass: #XPDLEventNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

XPDLEventNode subclass: #XPDLEndNode
	instanceVariableNames: 'inTransitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLEndNode methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 17:02'!
initialize

	super initialize.

	inTransitions := OrderedCollection new.! !

!XPDLEndNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:43'!
inTransitions
	^inTransitions! !

!XPDLEndNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:43'!
inTransitions: newValue
	inTransitions := newValue! !

!XPDLEndNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:43'!
isEndNode

	^true! !

XPDLEventNode subclass: #XPDLStartNode
	instanceVariableNames: 'outTransitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLStartNode methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 17:02'!
initialize

	super initialize.

	outTransitions := OrderedCollection new.! !

!XPDLStartNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:43'!
isStartNode

	^true! !

!XPDLStartNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:43'!
outTransitions
	^outTransitions! !

!XPDLStartNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:43'!
outTransitions: newValue
	outTransitions := newValue! !

XPDLObject2 subclass: #XPDLGatewayNode
	instanceVariableNames: 'inTransitions outTransitions type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLGatewayNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:36'!
initialize

	super initialize.

	inTransitions := OrderedCollection new.
	outTransitions := OrderedCollection new.! !

!XPDLGatewayNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:36'!
inTransitions
	^inTransitions! !

!XPDLGatewayNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:36'!
inTransitions: newValue
	inTransitions := newValue! !

!XPDLGatewayNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:36'!
outTransitions
	^outTransitions! !

!XPDLGatewayNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:36'!
outTransitions: newValue
	outTransitions := newValue! !

!XPDLGatewayNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:36'!
type
	^type! !

!XPDLGatewayNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:36'!
type: newValue
	type := newValue! !

XPDLObject2 subclass: #XPDLLaneNode
	instanceVariableNames: 'xpdlObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 16:57'!
initialize

	super initialize.

	xpdlObjects := OrderedCollection new.! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 09:21'!
rectangle

	^Rectangle origin: (self valueOf: 'x') @ (self valueOf: 'y') extent: (self valueOf: 'width') @ (self valueOf: 'height')! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 09:22'!
rectangleIncludesActivity: aXPDLObject

	^self rectangle containsPoint: aXPDLObject originPoint! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 09:29'!
setGraphicLaneValuesWithNode: xmlLaneNode
	"We set the graphic information of <newLane> using the XML node <xmlNode>"
	| gNode |

	gNode := xmlLaneNode findElementNamed: 'NodeGraphicsInfo'.
	self set: 'width' value: (Number readFrom: (gNode attributeAt: 'Width')).
	self set: 'height' value: (Number readFrom: (gNode attributeAt: 'Height')).

	gNode := xmlLaneNode findElementNamed: 'Coordinates'.
	self set: 'x' value: (Number readFrom: (gNode attributeAt: 'XCoordinate')).
	self set: 'y' value: (Number readFrom: (gNode attributeAt: 'YCoordinate')).! !

!XPDLLaneNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/24/2015 16:57'!
xpdlObjects
	^xpdlObjects! !

!XPDLLaneNode methodsFor: 'Updating' stamp: 'BrunoBB 10/24/2015 16:57'!
xpdlObjects: newValue
	xpdlObjects := newValue! !

!XPDLObject2 methodsFor: 'Accessing' stamp: 'BrunoBB 10/24/2015 16:45'!
attributes

   "Return the value of the instance variable 'attributes'."
   ^attributes! !

!XPDLObject2 methodsFor: 'Updating' stamp: 'BrunoBB 10/24/2015 16:45'!
attributes: newValue

   "Modify the value of the instance variable 'attributes'."
   attributes := newValue! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 16:45'!
getId

	^self valueOf: 'id'! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 16:45'!
getName

	^self valueOf: 'name'! !

!XPDLObject2 methodsFor: 'Updating' stamp: 'BrunoBB 10/24/2015 16:45'!
id: newValue

   "Modify the value of the instance variable 'id'."
	self set: 'id' value: newValue! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 16:45'!
initialize

	super initialize.

	attributes := Dictionary new.! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 09:43'!
inTransitions

	^#()! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:44'!
isEndNode

	^false! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:43'!
isStartNode

	^false! !

!XPDLObject2 methodsFor: 'Updating' stamp: 'BrunoBB 10/24/2015 16:45'!
name: newValue

   "Modify the value of the instance variable 'name'."

	self set: 'name' value: newValue! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 09:22'!
originPoint

	^(self valueOf: 'x') @ (self valueOf: 'y')! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 09:43'!
outTransitions

	^#()! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 16:45'!
removeAttribute: attrName 

	^attributes removeKey: attrName ifAbsent: []! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 16:45'!
set: attrName value: anObject

	^attributes at: attrName put: anObject! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:28'!
setGraphicActivityValuesWithNode: xmlNode
	"We set the graphic information of <newActivity> using the XML node <xmlNode>"
	| gNode |

	gNode := xmlNode findElementNamed: 'Coordinates'.
	self set: 'x' value: (Number readFrom: (gNode attributeAt: 'XCoordinate')).
	self set: 'y' value: (Number readFrom: (gNode attributeAt: 'YCoordinate')).! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:26'!
setLoopTypeWithNode: xmlNode
	"The receiver set it's loop type from the xml node <xmlNode>
	Loop type: (none) (standart) (multi-instance)"! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:20'!
setParentProcessDataWithNode: xmlNode! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 16:45'!
valueOf: attrName

	^attributes at: attrName ifAbsent: [nil]! !

!XPDLObject2 methodsFor: 'Accessing' stamp: 'BrunoBB 10/24/2015 16:45'!
xmlString

   "Return the value of the instance variable 'xmlString'."
   ^xmlString! !

!XPDLObject2 methodsFor: 'Updating' stamp: 'BrunoBB 10/24/2015 16:45'!
xmlString: newValue

   "Modify the value of the instance variable 'xmlString'."
   xmlString := newValue! !

XPDLObject2 subclass: #XPDLProcessNode
	instanceVariableNames: 'startNode endNodes lanes activities transitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLProcessNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:44'!
activities
	^activities! !

!XPDLProcessNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:44'!
activities: newValue
	activities := newValue! !

!XPDLProcessNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:44'!
addActivity: activityEventGateway

	^activities at: activityEventGateway getName put: activityEventGateway! !

!XPDLProcessNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:44'!
addLane: aXPDLLaneNode

	^lanes at: aXPDLLaneNode getName put: aXPDLLaneNode! !

!XPDLProcessNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 09:35'!
addTransition: aXPDLLaneNode

	^transitions add: aXPDLLaneNode! !

!XPDLProcessNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 09:53'!
connectActivitiesAndTrasitions

	self transitions do: [:eachTr | "connect transition start and end node with XPLDActivities"
		eachTr startNode: 
				(activities detect: [:eachAct | eachAct getId = eachTr startId] ifNone: [nil]).
		eachTr endNode: 
				(activities detect: [:eachAct | eachAct getId = eachTr endId] ifNone: [nil]).
		eachTr startNode addOutTransition: eachTr.
		eachTr endNode addInTransition: eachTr.].! !

!XPDLProcessNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 09:51'!
connectActivitiesToParentLane

	self lanes do: [:eachLane | "set the role of each transition -each activity inTransitions-"
		eachLane xpdlObjects: (self activities select: [:eachAct | eachLane rectangleIncludesActivity: eachAct]).
		eachLane xpdlObjects do: [:eachAct | 
			eachAct inTransitions do: [:eachTr | eachTr roles: (OrderedCollection with: eachLane getName)]]].! !

!XPDLProcessNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:45'!
initialize

	super initialize.

	activities := Dictionary new.
	lanes := Dictionary new.
	transitions := OrderedCollection new.
	endNodes := OrderedCollection new.! !

!XPDLProcessNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:44'!
lanes
	^lanes! !

!XPDLProcessNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:44'!
lanes: newValue
	lanes := newValue! !

!XPDLProcessNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:45'!
setStartAndEndNodes

	startNode := activities detect: [:each | each isStartNode].

	endNodes := activities select: [:each | each isEndNode].! !

!XPDLProcessNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:44'!
startNode
	^startNode! !

!XPDLProcessNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:44'!
startNode: newValue
	startNode := newValue! !

!XPDLProcessNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:44'!
transitions
	^transitions! !

!XPDLProcessNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:44'!
transitions: newValue
	transitions := newValue! !

XPDLObject2 subclass: #XPDLTransitionNode
	instanceVariableNames: 'startNode endNode startId endId startCondition expectedResult transitionPreviousFields roles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:40'!
endId
	^endId! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:40'!
endId: newValue
	endId := newValue! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:40'!
endNode
	^endNode! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:40'!
endNode: newValue
	endNode := newValue! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:40'!
expectedResult
	^expectedResult! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:40'!
expectedResult: newValue
	expectedResult := newValue! !

!XPDLTransitionNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 09:41'!
initialize

	super initialize.

	roles := OrderedCollection new.! !

!XPDLTransitionNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 09:40'!
setExtendedAttributesWithNode: xmlNode
	"The receiver set the extended attributes <expectedResult> and <transitionPreviousFields> supported by the Process Engine"

	xmlNode allElementsNamed: 'ExtendedAttribute' do: [:eachAttr |
		((eachAttr attributeAt: 'Name') = 'expectedResult')  "-extended attribute- a TextArea in Bizagi Modeler (value is a XML)"
		ifTrue: [self expectedResult: (XMLDOMParser parse: (eachAttr attributeAt: 'Value')) contentString].

		((eachAttr attributeAt: 'Name') = 'transitionPreviousFields') 
		ifTrue: [self transitionPreviousFields: (eachAttr attributeAt: 'Value')]."-extended attribute- a TextBox in Bizagi Modeler (value is a string)"
	].! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:40'!
startCondition
	^startCondition! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:40'!
startCondition: newValue
	startCondition := newValue! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:40'!
startId
	^startId! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:40'!
startId: newValue
	startId := newValue! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:40'!
startNode
	^startNode! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:40'!
startNode: newValue
	startNode := newValue! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:40'!
transitionPreviousFields
	^transitionPreviousFields! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:40'!
transitionPreviousFields: newValue
	transitionPreviousFields := newValue! !

Object subclass: #XPDLReader2
	instanceVariableNames: 'xmlDocument xpdlProcesses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

XPDLReader2 subclass: #BizagiXPDLReader2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLReader2 class methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 17:25'!
for: xpdlPathFile
	| file contents | 

	file:= FileStream fileNamed: xpdlPathFile.
	contents := file contents.
	file close.

	^self forString: contents! !

!XPDLReader2 class methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 17:25'!
forString: xmlString

	^super new initialize
		xmlDocument: (XMLDOMParser parse: xmlString);
		yourself! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 09:53'!
generateProcess
	| xpdlProcess |

	xpdlProcess := XPDLProcessNode new.
	xpdlProcess xmlString: self getPackageNode;
		id: self getProcessId;
		name: self getProcessName.

	self getLaneNodes do: [:each | xpdlProcess addLane: each].
	self getActivityNodes do: [:each | xpdlProcess addActivity: each].
	self getTransitionNodes do: [:each | xpdlProcess addTransition: each].

	xpdlProcess setStartAndEndNodes;
					connectActivitiesToParentLane;
					connectActivitiesAndTrasitions.

	^xpdlProcess! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:35'!
getActivityInstanceFrom: xmlActivityNode

	(xmlActivityNode findElementNamed: 'SubFlow') ifNotNil: [^XPDLSubProcessNode new].

	(xmlActivityNode findElementNamed: 'Route') 
	ifNotNil: [:node | | gate type | 
		gate := XPDLGatewayNode new.
		type := node attributeAt: 'GatewayType' ifAbsent: ['']. "set the type of the gateway"
		^gate type: type].

	(xmlActivityNode findElementNamed: 'StartEvent') ifNotNil: [^XPDLStartNode new].

	(xmlActivityNode findElementNamed: 'EndEvent') ifNotNil: [^XPDLEndNode new].

	^XPDLTaskNode new! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:31'!
getActivityNodes
	| nodes |

	nodes := OrderedCollection new.
	xmlDocument allElementsNamed: 'Activity' do: [:eachNode | | newActivity |
		newActivity := (self getActivityInstanceFrom: eachNode)
			id: (eachNode attributeAt: 'Id');
			name: (eachNode attributeAt: 'Name');
			xmlString: eachNode; "remove this later"
			yourself.
		newActivity 
			setLoopTypeWithNode: eachNode; "loop type: (none) (standart) (multi-instance) [only for Tasks and Subprocess nodes ]"
			setGraphicActivityValuesWithNode: eachNode; "set graphic coordinates [for all nodes]"
			setParentProcessDataWithNode: eachNode. "set the Id of the subprocess [only for Subprocess nodes]"

		nodes add: newActivity.].

	^nodes! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 09:30'!
getLaneNodes
	| nodes |

	nodes := OrderedCollection new.
	xmlDocument allElementsNamed: 'Lane' do: [:xmlLaneNode | | newLane |
		newLane := XPDLLaneNode new id: (xmlLaneNode attributeAt: 'Id');
			name: (xmlLaneNode attributeAt: 'Name');
			yourself.
		newLane setGraphicLaneValuesWithNode: xmlLaneNode.
		nodes add: newLane.].

	^nodes! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 17:48'!
getPackageNode
	| xmlNodes |

	xmlNodes := xmlDocument allElementsNamed: 'Package'.
	xmlNodes isEmpty ifTrue: [^nil].

	^xmlNodes first! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 17:49'!
getProcessId

	^self getPackageNode ifNil: [nil] ifNotNil: [:xmlNode | xmlNode attributeAt: 'Id']! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 17:57'!
getProcessName

	^self getPackageNode ifNil: [nil] ifNotNil: [:xmlNode | xmlNode attributeAt: 'Name']! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 09:38'!
getTransitionNodes
	| nodes |

	nodes := OrderedCollection new.
	xmlDocument allElementsNamed: 'Transition' do: [:eachNode | | newTransition startCond |
		startCond := eachNode findElementNamed: 'Expression'.
		startCond ifNotNil: [startCond := startCond contentString].
		newTransition := XPDLTransitionNode new id: (eachNode attributeAt: 'Id');
			name: (eachNode attributeAt: 'Name');
			startId: (eachNode attributeAt: 'From');
			endId: (eachNode attributeAt: 'To');
			startCondition: startCond;
			yourself.
		newTransition setExtendedAttributesWithNode: eachNode.
		nodes add: newTransition.].

	^nodes! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 17:25'!
initialize

	super initialize.

	xpdlProcesses := Dictionary new.! !

!XPDLReader2 methodsFor: 'Accessing' stamp: 'BrunoBB 10/24/2015 17:53'!
xmlDocument
	^xmlDocument! !

!XPDLReader2 methodsFor: 'Updating' stamp: 'BrunoBB 10/24/2015 17:53'!
xmlDocument: newValue
	xmlDocument := newValue! !

!XPDLReader2 methodsFor: 'Accessing' stamp: 'BrunoBB 10/24/2015 17:53'!
xpdlProcesses
	^xpdlProcesses! !

!XPDLReader2 methodsFor: 'Updating' stamp: 'BrunoBB 10/24/2015 17:53'!
xpdlProcesses: newValue
	xpdlProcesses := newValue! !
